<?php
/**
 * @package  eWay Rapid Joomla! HikaShop
 * @see      https://github.com/eWAYPayment/eway-rapid-php
 */
?><?php

namespace Eway;

use Eway\Rapid\Client;
use Eway\Rapid\Contract\Client as ClientContract;

abstract class Rapid
{
	private static $messages = null;

	public static function createClient($apiKey, $apiPassword, $endpoint = ClientContract::MODE_SANDBOX)
	{
		return new Client($apiKey, $apiPassword, $endpoint);
	}

	public static function getMessage($errorCode, $language = 'en')
	{
		self::_initMessages();

		$messagesByLanguage = self::_getMessagesByLanguage($language);
		if (!array_key_exists($errorCode, $messagesByLanguage)) {
			return $errorCode;
		}

		return $messagesByLanguage[$errorCode];
	}

	private static function _tryLoadingMessageFile($language)
	{
		$language = strtolower($language);
		$file = __DIR__.'/lang/'.$language.'.ini';
		if (file_exists($file)) {
			self::$messages[$language] = parse_ini_file($file);
		}
	}

	private static function _initMessages()
	{
		if (null === self::$messages) {
			self::$messages = [];
		}
	}

	private static function _getMessagesByLanguage($language)
	{
		$messages = [];

		if (!array_key_exists($language, self::$messages)) {
			self::_tryLoadingMessageFile($language);
		}

		if (array_key_exists($language, self::$messages)) {
			$messages = self::$messages[$language];
		} else {
			self::_tryLoadingMessageFile('en');
			if (array_key_exists('en', self::$messages)) {
				$messages = self::$messages['en'];
			}
		}

		return $messages;
	}
}
