<?php
/**
 * @package  eWay Rapid Joomla! HikaShop
 * @see      https://github.com/eWAYPayment/eway-rapid-php
 */
?><?php

namespace Eway\Rapid\Contract;

use Eway\Rapid\Model\Customer;
use Eway\Rapid\Model\Refund;
use Eway\Rapid\Model\Response\CreateCustomerResponse;
use Eway\Rapid\Model\Response\CreateTransactionResponse;
use Eway\Rapid\Model\Response\QueryCustomerResponse;
use Eway\Rapid\Model\Response\QueryTransactionResponse;
use Eway\Rapid\Model\Response\RefundResponse;
use Eway\Rapid\Model\Transaction;

interface Client
{

	const NAME = 'eWAY SDK PHP';

	const VERSION = '1.0.0';

	const MODE_SANDBOX = 'sandbox';

	const MODE_PRODUCTION = 'production';

	const ENDPOINT_SANDBOX = 'https://api.sandbox.ewaypayments.com/';

	const ENDPOINT_PRODUCTION = 'https://api.ewaypayments.com/';


	const ERROR_INVALID_JSON = 'S9901';

	const ERROR_EMPTY_RESPONSE = 'S9902';

	const ERROR_INVALID_ENDPOINT = 'S9990';

	const ERROR_INVALID_CREDENTIAL = 'S9991';

	const ERROR_CONNECTION_ERROR = 'S9992';

	const ERROR_HTTP_AUTHENTICATION_ERROR = 'S9993';

	const ERROR_HTTP_SERVER_ERROR = 'S9996';

	const ERROR_INVALID_ARGUMENT = 'S9995';

	public function isValid();

	public function getErrors();

	public function getEndpoint();

	public function setEndpoint($endpoint);

	public function setCredential($apiKey, $apiPassword);

	public function createTransaction($apiMethod, $transaction);

	public function queryTransaction($reference);

	public function queryInvoiceNumber($invoiceNumber);

	public function queryInvoiceReference($invoiceReference);

	public function createCustomer($apiMethod, $customer);

	public function queryCustomer($tokenCustomerId);

	public function refund($refund);

	public function cancelTransaction($transactionId);
}
