<?php
/**
 * @package  eWay Rapid Joomla! HikaShop
 * @see      https://github.com/eWAYPayment/eway-rapid-php
 */
?><?php

namespace Eway\Rapid\Contract;

use Eway\Rapid\Contract\Http\ResponseInterface;

interface HttpService
{

	const API_TRANSACTION = 'Transaction';

	const API_TRANSACTION_QUERY = 'Transaction/{Reference}';

	const API_TRANSACTION_INVOICE_NUMBER_QUERY = '/Transaction/InvoiceNumber/{InvoiceNumber}';

	const API_TRANSACTION_INVOICE_REFERENCE_QUERY = '/Transaction/InvoiceRef/{InvoiceReference}';

	const API_ACCESS_CODE = 'AccessCodes';

	const API_ACCESS_CODE_QUERY = 'AccessCode/{AccessCode}';

	const API_ACCESS_CODE_SHARED = 'AccessCodesShared';

	const API_CUSTOMER_QUERY = 'Customer/{TokenCustomerID}';

	const API_TRANSACTION_REFUND = 'Transaction/{TransactionID}/Refund';

	const API_CAPTURE_PAYMENT = 'CapturePayment';

	const API_CANCEL_AUTHORISATION = 'CancelAuthorisation';

	public function getTransaction($reference);

	public function getTransactionInvoiceNumber($invoiceNumber);

	public function getTransactionInvoiceReference($invoiceReference);


	public function postTransaction($data);


	public function postTransactionRefund($transactionId, $data);


	public function postAccessCodeShared($data);


	public function getAccessCode($accessCode);


	public function postAccessCode($data);


	public function getCustomer($tokenCustomerId);


	public function postCapturePayment($data);


	public function postCancelAuthorisation($data);

	public function setKey($key);

	public function getKey();

	public function setPassword($password);

	public function getPassword();

	public function setBaseUrl($baseUrl);

	public function getBaseUrl();
}
