<?php
/**
 * @package  eWay Rapid Joomla! HikaShop
 * @see      https://github.com/eWAYPayment/eway-rapid-php
 */
?><?php

namespace Eway\Rapid\Enum;

use Eway\Rapid\Model\Support\CanGetClassTrait;

abstract class AbstractEnum
{
	use CanGetClassTrait;

	private static $constCacheArray = null;

	private static $constValueCacheArray = null;

	public static function isValidValue($value, $strict = false)
	{
		$values = self::getConstantValues();

		return in_array($value, $values, $strict);
	}

	public static function getValidationMessage($name)
	{
		$allowedValues = self::getConstantValues();

		return sprintf('%s must be one of the following: %s', $name, implode(', ', $allowedValues));
	}

	public static function getOptionsArray()
	{
		return self::getConstants();
	}

	private static function getConstants()
	{
		if (null === self::$constCacheArray) {
			self::$constCacheArray = [];
		}
		$calledClass = get_called_class();
		if (!array_key_exists($calledClass, self::$constCacheArray)) {
			$reflect = new \ReflectionClass($calledClass);

			self::$constCacheArray[$calledClass] = $reflect->getConstants();
		}

		return self::$constCacheArray[$calledClass];
	}

	private static function getConstantValues()
	{
		if (null === self::$constValueCacheArray) {
			self::$constValueCacheArray = [];
		}
		$calledClass = get_called_class();
		if (!array_key_exists($calledClass, self::$constValueCacheArray)) {
			$reflect = new \ReflectionClass($calledClass);

			self::$constValueCacheArray[$calledClass] = array_values($reflect->getConstants());
		}

		return self::$constValueCacheArray[$calledClass];
	}
}
