<?php
/**
 * @package  eWay Rapid Joomla! HikaShop
 * @see      https://github.com/eWAYPayment/eway-rapid-php
 */
?><?php

namespace Eway\Rapid\Model;

use Eway\Rapid\Contract\Arrayable;
use Eway\Rapid\Model\Support\CanGetClassTrait;
use Eway\Rapid\Model\Support\CanValidateEnumTrait;
use Eway\Rapid\Model\Support\CanValidateInstanceTrait;
use Eway\Rapid\Model\Support\HasAttributesTrait;

abstract class AbstractModel implements Arrayable
{
	use HasAttributesTrait, CanValidateInstanceTrait, CanValidateEnumTrait, CanGetClassTrait;

	public function __construct(array $attributes = [])
	{
		$this->fill($attributes);
	}

	public function toJson($options = 0)
	{
		return json_encode($this->toArray(), $options);
	}

	public function toArray()
	{
		return $this->attributesToArray();
	}

	public function __toString()
	{
		return $this->toJson();
	}
}
