<?php
/**
 * @package  eWay Rapid Joomla! HikaShop
 * @see      https://github.com/eWAYPayment/eway-rapid-php
 */
?><?php

namespace Eway\Rapid\Model\Response;

use Eway\Rapid\Model\AbstractModel;

abstract class AbstractResponse extends AbstractModel
{
	protected $errors = [];

	public function getErrors()
	{
		$errors = array_key_exists('Errors', $this->attributes) ? $this->attributes['Errors'] : '';
		if (!is_string($errors) || strlen(trim($errors)) === 0) {
			$errors = [];
		} else {
			$errors = explode(',', $errors);
		}

		return array_merge($this->errors, $errors);
	}

	public function addError($errorCode)
	{
		$this->errors[] = $errorCode;
		if (!array_key_exists('Errors', $this->attributes)) {
			$this->attributes['Errors'] = '';
		}

		return $this;
	}
}
