<?php
/**
 * @package  eWay Rapid Joomla! HikaShop
 * @see      https://github.com/eWAYPayment/eway-rapid-php
 */
?><?php

namespace Eway\Rapid\Model;

use Eway\Rapid\Enum\ShippingMethod;

class ShippingAddress extends AbstractModel
{
	protected $fillable = [
		'FirstName',
		'LastName',
		'ShippingMethod',
		'Street1',
		'Street2',
		'City',
		'State',
		'Country',
		'PostalCode',
		'Email',
		'Phone',
		'Fax',
	];

	public function setShippingMethodAttribute($shippingMethod)
	{
		if (null === $shippingMethod) {
			$this->attributes['ShippingMethod'] = ShippingMethod::UNKNOWN;
		} else {
			$this->validateEnum('Eway\Rapid\Enum\ShippingMethod', 'ShippingMethod', $shippingMethod);
		}

		return $this;
	}
}
