<?php
/**
 * @package  eWay Rapid Joomla! HikaShop
 * @see      https://github.com/eWAYPayment/eway-rapid-php
 */
?><?php

namespace Eway\Rapid\Model;

use Eway\Rapid\Model\Support\HasBeagleVerificationTrait;
use Eway\Rapid\Model\Support\HasCustomerTrait;
use Eway\Rapid\Model\Support\HasItemsTrait;
use Eway\Rapid\Model\Support\HasOptionsTrait;
use Eway\Rapid\Model\Support\HasPaymentTrait;
use Eway\Rapid\Model\Support\HasShippingAddressTrait;
use Eway\Rapid\Model\Support\HasTransactionTypeTrait;
use Eway\Rapid\Model\Support\HasVerificationTrait;

class Transaction extends AbstractModel
{
	use HasTransactionTypeTrait,
		HasCustomerTrait,
		HasShippingAddressTrait,
		HasPaymentTrait,
		HasItemsTrait,
		HasOptionsTrait,
		HasBeagleVerificationTrait,
		HasVerificationTrait;

	protected $fillable = [
		'TransactionType',
		'Capture',
		'Customer',
		'CustomerIP',
		'CustomerNote',
		'CustomerReadOnly',
		'CustomView',
		'TokenCustomerID',

		'ShippingAddress',
		'Payment',
		'TotalAmount',
		'InvoiceNumber',
		'InvoiceDescription',
		'InvoiceReference',
		'CurrencyCode',

		'Items',
		'Options',
		'DeviceID',
		'PartnerID',
		'ThirdPartyWalletID',
		'AuthTransactionID',
		'RedirectUrl',
		'CancelUrl',
		'CheckoutUrl',
		'CheckoutPayment',

		'HeaderText',
		'Language',
		'LogoUrl',

		'AuthorisationCode',
		'BeagleVerification',
		'Method',

		'TransactionStatus',
		'BeagleScore',
		'Captured',
		'FraudAction',
		'Status',
		'Total',
		'TransactionID',

		'Verification',
		'Address',
		'BeagleEmail',
		'BeaglePhone',
		'CVN',
		'Email',
		'Mobile',
		'Phone',

		'ProcessingDetails',
		'AuthorisationCode',
		'ResponseCode',
		'ResponseMessage',

		'VerifyCustomerEmail',
		'VerifyCustomerPhone',
	];

	public function __construct(array $attributes = [])
	{
		if (!isset($attributes['Capture'])) {
			$attributes['Capture'] = true;
		}

		parent::__construct($attributes);
	}
}
